program DM_Inst;

uses dos, crt, utils;

const numnewchars=255;      {number of chars to redefine}

{$M $4000,0,0}
{$I DEMLOGO.PAS}

type Configuration = record
       userfile, textdir, menu1, menu2, menu3, menu4, menu5 : string;
     end;
     Cfgfile = file of Configuration;

var quit, cfgdone, tmpb : boolean;
    config : Configuration;
    instdir : string;

Procedure LoadChar;
  type bytearray=array[0..15] of byte;
       chararray=array[1..numnewchars] of record
         charnum:byte;
         chardata:bytearray;
       end;

  {$I SM.FNT}

  var regs:registers; i:byte;
  begin
    for i:=1 to numnewchars do begin
      with regs do begin
        ah:=$11;  { video sub-Function $11 }
        al:=$0;   { Load Chars to table $1 }
        bh:=$10;  { number of Bytes per Char $10 }
        bl:=0;    { Character table to edit }
        cx:=1;    { number of Chars we're definig }
        dx:=newchars[i].charnum;
        es:=seg(newchars[i].chardata);
        bp:=ofs(newchars[i].chardata);
        intr($10,regs);
      end;
    end;
  end;

procedure pause;
  var tmp : char;
  begin
    writeln('Press Any Key to Continue...');
    tmp := readkey;
  end;

procedure Setup;
  var yn : boolean;
      s, tmps : string;
      counter : shortint;
      tmp : char;
  begin
    if fileexist('d-menu.cfg') then begin
      yn := FALSE;
      tc(4);
      tg(0);
      writeln('Warning: Your Config File Already Exists...');
      write('Do You Wish To Overwrite? [Y/N] ');
      tmp := readkey;
      write(tmp);
      writeln;
      case tmp of
        #78: halt;
      end;
    end;
    clrscr;
    tc(7);
    tg(0);
    write('What is The Filename of The Userfile? (ex. D-Menu.usr) ');
      readln(config.userfile);
    write('Directory To Copy The Menu''s To (ex. C:\TG\TEXT): ');
      readln(config.textdir);
      if not direxist(config.textdir) then begin
        writeln;
        tc(4);
        tg(0);
        writeln('Warning: The Directory You Specified Does Not Exist.');
        if YesNo('Ok To Create? [Y/N] ') then mkdir(config.textdir)
        else begin
          tc(4);
          tg(0);
          writeln('Warning: The Directory ', config.textdir, 'Has Not Been Created.');
        end;
        tc(7);
        tg(0);
      end;
      counter := 1;
      repeat
        tmps := itos(counter);
        tmps := config.textdir + '\menu' + tmps;
        if not direxist(tmps) then begin
          tc(4);
          tg(0);
          if yn = FALSE then begin
            writeln('Warning: The Menu Directories Do Not Exist.');
            tc(7);
            tg(0);
            if YesNo('Ok To Create? [Y/N] ') then begin
              mkdir(tmps);
              writeln('created directory: ' + tmps);
              yn := TRUE;
            end;
          end
          else begin
            mkdir(tmps);
            writeln('Created Directory: ' + tmps);
          end;
        end;
        inc(counter);
      until counter > 5;
      tc(7);
    write('Description of Menu Set #1 (20 char''s max): ');
      readln(config.menu1);
    write('Description of Menu Set #2 (20 char''s max): ');
      readln(config.menu2);
    write('Description of Menu Set #3 (20 char''s max): ');
      readln(config.menu3);
    write('Description of Menu Set #4 (20 char''s max): ');
      readln(config.menu4);
    write('Description of Menu Set #5 (20 char''s max): ');
      readln(config.menu5);
    writeln;
    writeln('D-Menu Configured Successfully...');
    cfgdone := TRUE;
  end;

procedure Extract;
  var f1, f2 : file;
      numr, numw : word;
      buf : array[1..2048] of char;
  begin
    assign(f1, paramstr(0));
    reset(f1, 1);
    seek(f1, exesize(paramstr(0)));
    assign(f2, '!@#$%^&*.exe');
    rewrite(f2, 1);
    repeat
      BlockRead(f1, buf, sizeof(buf), numr);
      BlockWrite(f2, buf, numr, numw);
    until (numr = 0) or (numw <> numr);
    close(f1);
    close(f2);
  end;

procedure Install;
  var f1, tmpf : file;
      f2 : cfgfile;
  begin
    if cfgdone = FALSE then begin
      writeln;
      writeln;
      writeln('Error: You Haven''t Configured D-Menu Yet.');
      pause;
      exit;
    end;
    clrscr;
    write('What Directory Would You Like D-Menu Installed To? ');
    readln(instdir);
    extract;
    swapvectors;
    exec(getenv('COMSPEC'), '/c !@#$%^&*.exe -do ' + InstDir + ' > 0991583.$$$');
    swapvectors;
    assign(f1, 'files.exe');
    erase(f1);
    assign(tmpf, '0991583.$$$');
    erase(tmpf);
    assign(f2, instdir + '\d-menu.cfg');
    rewrite(f2);
    write(f2, config);
    writeln;
    tc(12);
    writeln('D-Menu Installed Successfully.');
    pause;
  end;

procedure MainMenu;
  var counter : shortint;
      key : char;
  begin
    clrscr;
    counter := 1;
    repeat
      setbar(1, counter, 29, 12, 76, 07, 'Configure D-Menu');
      setbar(2, counter, 29, 13, 76, 07, 'Install D-Menu');
      setbar(3, counter, 29, 14, 76, 07, 'Quit');
      key := readkey;
      case key of
        #0 : begin
          key := readkey;
          case key of
            #72, #75: begin
              if counter>1 then dec(counter)
              else counter := 3;
            end;
            #80, #77: begin
              if counter<3 then inc(counter)
              else counter := 1;
            end;
          end;
        end;
        #13:case counter of
          1: begin
            Setup;
            exit;
          end;
          2: begin
            Install;
            exit;
          end;
          3: begin
            quit := TRUE;
            exit;
          end;
        end;
      end;
    until 1 = 0;
  end;

procedure Intro;
  var counter : shortint;
  begin
    grabpal;
    fadeout;
    clrscr;
    loadchar;
    uncrunch(DEM_LOGO, screenaddr[(1*2)+(1*160)-162], DEM_LOGO_Length);
    fadein;
    delay(3000);
    fadeout;
    clrscr;
    setbar(1, counter, 29, 12, 76, 07, 'Configure D-Menu');
    setbar(2, counter, 29, 13, 76, 07, 'Install D-Menu');
    setbar(3, counter, 29, 14, 76, 07, 'Quit');
    fadein;
  end;

begin
  quit := FALSE;
  cfgdone := FALSE;
  Intro;
  repeat
    clrscr;
    MainMenu;
  until quit = TRUE;
  fadeout;
  tg(0);
  clrscr;
  textmode(CO80);
  fadein;
end.